## altos 1.8

=== doc/Makefile ===
#
#	http://docbook.sourceforge.net/release/xsl/current/README
#

RELNOTES_INC=\
	release-notes-1.8.inc \
	release-notes-1.7.inc \
	release-notes-1.6.8.inc \
	release-notes-1.6.5.inc \
	release-notes-1.6.4.inc \
	release-notes-1.6.3.inc \
	release-notes-1.6.2.inc \
	release-notes-1.6.1.inc \
	release-notes-1.6.inc \
	release-notes-1.5.inc \
	release-notes-1.4.2.inc \
	release-notes-1.4.1.inc \
	release-notes-1.4.inc \
	release-notes-1.3.2.inc \
	release-notes-1.3.1.inc \
	release-notes-1.3.inc \
	release-notes-1.2.1.inc \
	release-notes-1.2.inc \
	release-notes-1.1.1.inc \
	release-notes-1.1.inc \
	release-notes-1.0.1.inc \
	release-notes-0.9.2.inc \
	release-notes-0.9.inc \
	release-notes-0.8.inc \
	release-notes-0.7.1.inc

IMAGES=\
	altosui.png \
	ascent.png \
	configure-altimeter.png \
	configure-altosui.png \
	configure-groundstation.png \
	configure-pyro.png \
	descent.png \
	device-selection.png \
	easymega.svg \
	easymega-v1.0-bottom.jpg \
	easymega-v1.0-top.jpg \
	easymini.svg \
	easymini-top.jpg \
	fire-igniter.png \
	graph-configure.png \
	graph-map.png \
	graph.png \
	graph-stats.png \
	ignitor.png \
	landed.png \
	launch-pad.png \
	load-maps.png \
	micropeak-app.png \
	micropeak-back.jpg \
	micropeak-device-dialog.png \
	micropeak-dime.jpg \
	micropeak-download.png \
	micropeak-graph-configure.png \
	micropeak-graph.png \
	micropeak-nofont.svg \
	micropeak-preferences.png \
	micropeak-raw-data.png \
	micropeak-save-dialog.png \
	micropeak-statistics.png \
	MicroPeakUSB-2.0-inuse.jpg \
	MicroPeakUSB-2.0.jpg \
	monitor-idle.png \
	scan-channels.png \
	site-map.png \
	table.png \
	telegps-configure.png \
	telegps-graph-configure.png \
	telegps-graph-graph.png \
	telegps-graph-map.png \
	telegps-graph-stats.png \
	telegps-info.png \
	telegps-location.png \
	telegps-map.png \
	telegps-preferences.png \
	telegps-scan.png \
	telegps-status.png \
	telegps-table.png \
	telegps-v1.0-top.jpg \
	telemega.svg \
	telemega-v1.0-top.jpg \
	telemetrum.svg \
	telemetrum-v1.1-thside.jpg \
	telemetrum-v2.0-th.jpg \
	telemini-v1.svg \
	telemini-v1-top.jpg \
	telemini-v3.svg \
	telemini-v3.0-top.jpg \
	telemini-v3.0-bottom.jpg \
	altusmetrum-oneline.svg \
	telegps-oneline.svg \
	micropeak-oneline.svg

TXT_FILES=altusmetrum.txt

COMMON_INC_FILES=\
	config-device.inc \
	config-ui.inc \
	load-maps.inc \
	aprs-operation.inc \
	handling.inc

INC_FILES=\
	dedication.inc \
	intro.inc \
	getting-started.inc \
	usage.inc \
	telemetrum.inc \
	telemini.inc \
	easymini-device.inc \
	telemega.inc \
	easymega.inc \
	installation.inc \
	using-am-products.inc \
	updating-firmware.inc \
	altosui.inc \
	altosdroid.inc \
	system-operation.inc \
	pyro-channels.inc \
	flight-data-recording.inc \
	specs.inc \
	$(COMMON_INC_FILES) \
	release-notes.inc \
	$(RELNOTES_INC)

RAW_FILES=$(TXT_FILES:.txt=.raw) $(INC_FILES:.inc=.raw)

TELEGPS_INC_FILES=\
	telegps-dedication.inc \
	telegps-quick-start.inc \
	telegps-using.inc \
	telegps-system-operation.inc \
	telegps-application.inc \
	telegps-specs.inc \
	telegps-updating-firmware.inc \
	telegps-release-notes.inc \
	$(COMMON_INC_FILES)

TELEGPS_TXT_FILES=\
	telegps.txt

TELEGPS_RAW_FILES=$(TELEGPS_TXT_FILES:.txt=.raw) $(TELEGPS_INC_FILES:.inc=.raw)

MICROPEAK_TXT_FILES=\
	micropeak.txt

MICROPEAK_INC_FILES=

MICROPEAK_RAW_FILES=$(MICROPEAK_TXT_FILES:.txt=.raw) $(MICROPEAK_INC_FILES:.inc=.raw)

EASYMINI_TXT_FILES=\
	easymini.txt

EASYMINI_INC_FILES=$(INC_FILES) easymini-release-notes.inc


EASYMINI_RAW_FILES=$(EASYMINI_TXT_FILES:.txt=.raw) $(EASYMINI_INC_FILES:.inc=.raw)

OUTLINE_TXT_FILES=\
	easymega-outline.txt \
	easymini-outline.txt \
	telemega-outline.txt \
	telemetrum-outline.txt \
	telemini-v1-outline.txt \
	telemini-v3-outline.txt \
	telegps-outline.txt

OUTLINE_RAW_FILES=$(OUTLINE_TXT_FILES:.txt=.raw)

OUTLINE_PDF_FILES=$(OUTLINE_TXT_FILES:.txt=.pdf)

SVG=\
	easymini.svg \
	telemega.svg \
	telemetrum.svg \
	telemini-v1.svg \
	telemini-v3.svg \
	easymega.svg

RELNOTES_PDF=$(RELNOTES_INC:.inc=.pdf)
RELNOTES_HTML=$(RELNOTES_INC:.inc=.html)

ONEFILE_TXT_FILES=\
	altos.txt \
	companion.txt \
	telemetry.txt

ONEFILE_RAW_FILES=$(ONEFILE_TXT_FILES:.txt=.raw)
ONEFILE_PDF_FILES=$(ONEFILE_TXT_FILES:.txt=.pdf)

AM_HTML=am.html

HTML=altusmetrum.html micropeak.html telegps.html easymini.html $(RELNOTES_HTML) $(ONEFILE_HTML_FILES)

HTML_REVHISTORY=\
	altusmetrum-revhistory.html \
	micropeak-revhistory.html \
	telegps-revhistory.html \
	easymini-revhistory.html

PDF=altusmetrum.pdf micropeak.pdf telegps.pdf easymini.pdf $(RELNOTES_PDF) $(ONEFILE_PDF_FILES) \
	$(OUTLINE_PDF_FILES)

FOP_STYLE=am-fo.xsl
HTML_STYLE=am-html.xsl
COMMON_STYLE=common.xsl
FOP_XCONF=fop.xconf
STYLESHEET=am.css

FONTS=\
	fonts/DejaVuSansMono-BoldOblique.ttf \
	fonts/DejaVuSansMono-Bold.ttf \
	fonts/DejaVuSansMono-Oblique.ttf \
	fonts/DejaVuSansMono.ttf \
	fonts/OpenSans-Light.ttf \
	fonts/OpenSans-LightItalic.ttf \
	fonts/OpenSans-Regular.ttf \
	fonts/OpenSans-Italic.ttf \
	fonts/OpenSans-Semibold.ttf \
	fonts/OpenSans-SemiboldItalic.ttf

TEMPLATES_TMPL=titlepage.templates.tmpl

TEMPLATES_XSL=$(TEMPLATES_TMPL:.tmpl=.xsl)

PDF_CONFIG_FILES=$(FOP_STYLE) $(COMMON_STYLE) $(FOP_XCONF) $(TEMPLATES_XSL)
HTML_CONFIG_FILES=$(HTML_STYLE) $(COMMON_STYLE) $(TEMPLATES_XSL)

DOC=$(HTML) $(HTML_REVHISTORY) $(PDF) $(IMAGES) $(STYLESHEET)

.SUFFIXES: .tmpl .xsl .inc .txt .raw .pdf .html

.txt.raw:
	sed -e 's/^[ 	]*//' -e 's/^\\//' $*.txt > $@

.inc.raw:
	sed -e 's/^[ 	]*//' -e 's/^\\//' $*.inc > $@

.raw.pdf:
	a2x --verbose -a docinfo -f pdf --xsltproc-opts "--stringparam toc.section.depth 2" --xsl-file $(FOP_STYLE) --fop --fop-opts="-c $(FOP_XCONF)" $*.raw
	a2x --verbose -a docinfo -f xhtml --xsltproc-opts "--stringparam toc.section.depth 2" --xsl-file $(HTML_STYLE) --stylesheet=$(STYLESHEET) $*.raw
	case $* in release-notes*) ./fix-html $*.html ;; esac

.pdf.html:
	@touch $@

.tmpl.xsl:
	xsltproc --output $@ /usr/share/xml/docbook/stylesheet/docbook-xsl/template/titlepage.xsl $*.tmpl

all:	$(HTML) $(PDF)

altusmetrum-revhistory.html: altusmetrum.html

micropeak-revhistory.html: micropeak.html

telegps-revhistory.html: telegps.html

altusmetrum.pdf altusmetrum.html: altusmetrum-docinfo.xml $(RAW_FILES) $(IMAGES)

telegps.html telegps.pdf: telegps-docinfo.xml $(TELEGPS_RAW_FILES) $(IMAGES)

micropeak.pdf micropeak.html: micropeak-docinfo.xml $(MICROPEAK_RAW_FILES) $(IMAGES)

easymini.pdf easymini.html: easymini-docinfo.xml $(EASYMINI_RAW_FILES) $(IMAGES)

telemini-v1-outline.pdf: telemini-v1-outline.txt telemini-v1.svg

telemini-v3-outline.pdf: telemini-v3-outline.txt telemini-v3.svg

install:	all

publish:	$(DOC) $(FONTS)
	cp $(DOC) /home/bdale/web/altusmetrum/AltOS/doc/
	mkdir -p /home/bdale/web/altusmetrum/AltOS/doc/fonts/
	cp $(FONTS) /home/bdale/web/altusmetrum/AltOS/doc/fonts/
	(cd /home/bdale/web/altusmetrum ; \
	 git add /home/bdale/web/altusmetrum/AltOS/doc/* ; \
	 git add /home/bdale/web/altusmetrum/AltOS/doc/fonts/* ; \
	 echo "update docs" | \
	 git commit -F - /home/bdale/web/altusmetrum/AltOS/doc/* /home/bdale/web/altusmetrum/AltOS/doc/fonts/* ; \
	 git push)

publish-keithp:	am.html $(DOC) $(FONTS)
	scp -p am.html $(DOC) keithp.com:~keithp/public_html/altos
	scp -p $(FONTS) keithp.com:~keithp/public_html/altos/fonts

clean:
	rm -f am.html $(HTML) $(HTML_REVHISTORY) $(PDF) $(TEMPLATES_XSL) $(RAW_FILES) $(TELEGPS_RAW_FILES) $(MICROPEAK_RAW_FILES)

distclean: clean
	rm -f $(HTML) $(PDF)

$(PDF): $(PDF_CONFIG_FILES)
$(HTML): $(HTML_CONFIG_FILES)

am.html: Makefile make-am-html $(HTML)
	sh ./make-am-html $(HTML) > $@

=== src/Makefile ===
#
# AltOS build
#

vpath make-altitude util
vpath make-altitude-pa util
vpath make-kalman util
vpath make-whiten util
vpath kalman.5c kalman
vpath kalman_filter.5c kalman
vpath kalman_micro.5c kalman
vpath load_csv.5c kalman
vpath matrix.5c kalman

include Version
TOPDIR=.
include Makedefs

SDCCDIRS=\
	telemetrum-v1.2 telemetrum-v1.1 telemetrum-v1.0 \
	teledongle-v0.2 \
	telemini-v1.0 \
	telebt-v1.0 \
	teleterra-v0.2 teleshield-v0.1 \
	telefire-v0.1 telefire-v0.2 \
	telerepeat-v1.0

ARMM3DIRS=\
	easymega-v1.0 easymega-v1.0/flash-loader \
	telemega-v0.1 telemega-v0.1/flash-loader \
	telemega-v1.0 telemega-v1.0/flash-loader \
	telemega-v2.0 telemega-v2.0/flash-loader \
	telemetrum-v2.0 telemetrum-v2.0/flash-loader \
	telemetrum-v3.0 telemetrum-v3.0/flash-loader \
	megadongle-v0.1 megadongle-v0.1/flash-loader \
	telegps-v0.3 telegps-v0.3/flash-loader \
	telegps-v1.0 telegps-v1.0/flash-loader \
	telelco-v0.2 telelco-v0.2/flash-loader \
	telelco-v0.3 telelco-v0.3/flash-loader \
	telescience-v0.2 telescience-v0.2/flash-loader \
	teledongle-v3.0 teledongle-v3.0/flash-loader \
	teleballoon-v2.0 \
	telebt-v3.0 telebt-v3.0/flash-loader \
	telebt-v4.0 telebt-v4.0/flash-loader \
	telelcotwo-v0.1 telelcotwo-v0.1/flash-loader \
	telefiretwo-v0.1 telefiretwo-v0.1/flash-loader \

ARMM0DIRS=\
	easymini-v1.0 easymini-v1.0/flash-loader \
	chaoskey-v0.1 chaoskey-v0.1/flash-loader \
	chaoskey-v1.0 chaoskey-v1.0/flash-loader \
	telemini-v3.0 telemini-v3.0/flash-loader \
	easymini-v2.0 easymini-v2.0/flash-loader \
	micropeak-v2.0 micropeak-v2.0/flash-loader

AVRDIRS=\
	telescience-v0.1 telescience-pwm micropeak nanopeak-v0.1 microkite

SUBDIRS=

ifeq ($(strip $(HAVE_PDCLIB)),yes)
PDCLIB=pdclib
CLEAN_PDCLIB=clean-pdclib
endif

ifeq ($(strip $(HAVE_SDCC)),yes)
SUBDIRS+=$(SDCCDIRS)
endif

ifeq ($(strip $(HAVE_ARM_M3_CC)),yes)
SUBDIRS+=$(ARMM3DIRS)
foo=bar
endif

ifeq ($(strip $(HAVE_ARM_M0_CC)),yes)
SUBDIRS+=$(ARMM0DIRS)
baz=bletch
endif

ifeq ($(strip $(HAVE_AVR_CC)),yes)
SUBDIRS += $(AVRDIRS)
endif

ALLDIRS=$(SDCCDIRS) $(ARMM3DIRS) $(ARMM0DIRS) $(AVRDIRS)

all: all-local all-recursive

RECURSIVE_TARGETS = all-recursive install-recursive

$(RECURSIVE_TARGETS):
	@target=`echo $@ | sed 's/-recursive//'`; \
	for subdir in $(SUBDIRS); do \
		echo "Making $$target in $$subdir"; \
		(cd $$subdir && $(MAKE) $$target) || exit 1; \
	done

ALL_RECURSIVE_TARGETS = clean-recursive

$(ALL_RECURSIVE_TARGETS):
	@target=`echo $@ | sed 's/-recursive//'`; \
	for subdir in $(ALLDIRS); do \
		echo "Making $$target in $$subdir"; \
		(cd $$subdir && $(MAKE) $$target) || exit 1; \
	done

distclean:	clean

clean: clean-local clean-recursive

install: install-recursive

uninstall:

all-recursive: all-local

all-local: altitude.h altitude-pa.h altitude-pa-small.h ao_kalman.h ao_whiten.h $(PDCLIB)

altitude.h: make-altitude
	nickle $< > $@

altitude-pa.h: make-altitude-pa
	nickle $< > $@

altitude-pa-small.h: make-altitude-pa
	nickle $< --sample 3 > $@

ao_kalman.h: make-kalman kalman.5c kalman_micro.5c kalman_filter.5c load_csv.5c matrix.5c
	bash $< kalman > $@

ao_whiten.h: make-whiten
	nickle $< > $@

clean-local: $(CLEAN_PDCLIB)
	rm -f altitude.h ao_kalman.h

pdclib:
	mkdir -p $(PDCLIB_ROOT)/include $(PDCLIB_ROOT)/lib 
	cd ../pdclib && make && make prefix=`pwd`/../pdclib-root install

clean-pdclib:
	rm -rf $(PDCLIB_ROOT)
	cd ../pdclib && make clean

=== src/cortexelf-v1/Makefile ===
#
# AltOS build
#
#

include ../stm/Makefile.defs
LDFLAGS=-L../stm -Wl,-Tcortexelf.ld

INC = \
	ao.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_boot.h \
	ao_pins.h \
	ao_kalman.h \
	ao_product.h \
	ao_profile.h \
	ao_task.h \
	math.h \
	ao_mpu.h \
	stm32l.h \
	math.h \
	ao_vga.h \
	ao_draw.h \
	ao_draw_int.h \
	ao_font.h \
	ao_ps2.h \
	ao_lisp.h \
	ao_lisp_const.h \
	ao_lisp_os.h \
	ao_flip_bits.h \
	Makefile

#PROFILE=ao_profile.c
#PROFILE_DEF=-DAO_PROFILE=1

#STACK_GUARD=ao_mpu_stm.c
#STACK_GUARD_DEF=-DHAS_STACK_GUARD=1


ALTOS_SRC = \
	ao_boot_chain.c \
	ao_interrupt.c \
	ao_product.c \
	ao_romconfig.c \
	ao_cmd.c \
	ao_config.c \
	ao_task.c \
	ao_stdio.c \
	ao_panic.c \
	ao_timer.c \
	ao_mutex.c \
	ao_serial_stm.c \
	ao_dma_stm.c \
	ao_spi_stm.c \
	ao_usb_stm.c \
	ao_exti_stm.c \
	ao_i2c_stm.c \
	ao_as1107.c \
	ao_matrix.c \
	ao_vga.c \
	ao_blt.c \
	ao_copy.c \
	ao_rect.c \
	ao_text.c \
	ao_line.c \
	ao_ps2.c \
	ao_console.c \
	ao_sdcard.c \
	ao_bufio.c \
	ao_fat.c \
	ao_flash_stm.c \
	ao_button.c \
	ao_event.c \
	ao_1802.c \
	ao_hex.c \
	ao_lisp_lex.c \
	ao_lisp_mem.c \
	ao_lisp_cons.c \
	ao_lisp_eval.c \
	ao_lisp_string.c \
	ao_lisp_atom.c \
	ao_lisp_int.c \
	ao_lisp_poly.c \
	ao_lisp_builtin.c \
	ao_lisp_read.c \
	ao_lisp_rep.c \
	ao_lisp_frame.c \
	ao_lisp_error.c \
	ao_lisp_lambda.c \
	ao_lisp_save.c \
	ao_lisp_stack.c \
	ao_lisp_os_save.c \
	$(PROFILE) \
	$(SAMPLE_PROFILE) \
	$(STACK_GUARD)

PRODUCT=CortexELF-v1
PRODUCT_DEF=-DCORTEXELF
IDPRODUCT=0x000a

CFLAGS = $(PRODUCT_DEF) $(STM_CFLAGS) $(PROFILE_DEF) $(SAMPLE_PROFILE_DEF) $(STACK_GUARD_DEF) -Os -g

PROGNAME=cortexelf-v1
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx

SRC=$(ALTOS_SRC) ao_cortexelf.c
OBJ=$(SRC:.c=.o)

all:: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ) cortexelf.ld
	$(call quiet,CC) $(LDFLAGS) $(CFLAGS) -o $(PROG) $(OBJ) $(LIBS)

../altitude-pa.h: make-altitude-pa
	nickle $< > $@

$(OBJ): $(INC)

ao_product.h: ao-make-product.5c ../Version
	$(call quiet,NICKLE,$<) $< -m altusmetrum.org -i $(IDPRODUCT) -p $(PRODUCT) -v $(VERSION) > $@

distclean:	clean

clean::
	rm -f *.o $(PROGNAME)-*.elf $(PROGNAME)-*.ihx
	rm -f ao_product.h ao_flip_bits.h

ao_flip_bits.h: ao_flip_bits.5c
	nickle ao_flip_bits.5c > $@

include ../lisp/Makefile-lisp

install:

uninstall:

=== src/lambdakey-v1.0/Makefile ===
#
# AltOS build
#
#

include ../stmf0/Makefile.defs

INC = \
	ao.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_boot.h \
	ao_pins.h \
	ao_product.h \
	ao_task.h \
	ao_lisp.h \
	ao_lisp_const.h \
	ao_lisp_os.h \
	stm32f0.h \
	Makefile

ALTOS_SRC = \
	ao_boot_chain.c \
	ao_interrupt.c \
	ao_product.c \
	ao_romconfig.c \
	ao_cmd.c \
	ao_config.c \
	ao_task.c \
	ao_led.c \
	ao_dma_stm.c \
	ao_stdio.c \
	ao_mutex.c \
	ao_panic.c \
	ao_timer.c \
	ao_usb_stm.c \
	ao_flash_stm.c \
	ao_lisp_lex.c \
	ao_lisp_mem.c \
	ao_lisp_cons.c \
	ao_lisp_eval.c \
	ao_lisp_string.c \
	ao_lisp_atom.c \
	ao_lisp_int.c \
	ao_lisp_poly.c \
	ao_lisp_builtin.c \
	ao_lisp_read.c \
	ao_lisp_rep.c \
	ao_lisp_frame.c \
	ao_lisp_error.c \
	ao_lisp_lambda.c \
	ao_lisp_save.c \
	ao_lisp_stack.c \
	ao_lisp_os_save.c

PRODUCT=LambdaKey-v1.0
PRODUCT_DEF=-DLAMBDAKEY
IDPRODUCT=0x000a

CFLAGS = $(PRODUCT_DEF) -I. $(STMF0_CFLAGS) -Os -g

LDFLAGS=$(CFLAGS) -L$(TOPDIR)/stmf0 -Wl,-Tlambda.ld

PROGNAME=lambdakey-v1.0
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx

SRC=$(ALTOS_SRC) ao_lambdakey.c
OBJ=$(SRC:.c=.o)

all: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ) lambda.ld altos.ld
	$(call quiet,CC) $(LDFLAGS) $(CFLAGS) -o $(PROG) $(OBJ) $(LIBS)

$(OBJ): $(INC)

ao_product.h: ao-make-product.5c ../Version
	$(call quiet,NICKLE,$<) $< -m altusmetrum.org -i $(IDPRODUCT) -p $(PRODUCT) -v $(VERSION) > $@

load: $(PROG)
	stm-load $(PROG)

distclean:	clean

clean:
	rm -f *.o $(PROGNAME)-*.elf $(PROGNAME)-*.ihx
	rm -f ao_product.h

install:

uninstall:

=== src/lisp/Makefile ===
all: ao_lisp_const.h

clean:
	rm -f ao_lisp_const.h $(OBJS) ao_lisp_make_const

ao_lisp_const.h: ao_lisp_const.lisp ao_lisp_make_const
	./ao_lisp_make_const -o $@ ao_lisp_const.lisp

include Makefile-inc
SRCS=$(LISP_SRCS)

HDRS=$(LISP_HDRS)

OBJS=$(SRCS:.c=.o)

CFLAGS=-DAO_LISP_MAKE_CONST -O0 -g -I. -Wall -Wextra -no-pie


ao_lisp_make_const:  $(OBJS)
	$(CC) $(CFLAGS) -o $@ $(OBJS)

$(OBJS): $(HDRS)

=== src/test/Makefile ===
vpath % ..:../kernel:../drivers:../util:../micropeak:../aes:../product:../lisp

PROGS=ao_flight_test ao_flight_test_baro ao_flight_test_accel ao_flight_test_noisy_accel ao_flight_test_mm \
	ao_flight_test_metrum ao_flight_test_mini \
	ao_gps_test ao_gps_test_skytraq ao_gps_test_ublox ao_convert_test ao_convert_pa_test ao_fec_test \
	ao_aprs_test ao_micropeak_test ao_fat_test ao_aes_test ao_int64_test \
	ao_ms5607_convert_test ao_quaternion_test ao_lisp_test

INCS=ao_kalman.h ao_ms5607.h ao_log.h ao_data.h altitude-pa.h altitude.h ao_quaternion.h

KALMAN=make-kalman 

CFLAGS=-I.. -I. -I../kernel -I../drivers -I../micropeak -I../product -I../lisp -O0 -g -Wall -DAO_LISP_TEST -no-pie

all: $(PROGS) ao_aprs_data.wav

clean:
	rm -f $(PROGS) ao_aprs_data.wav run-out.baro run-out.full

install:

ao_flight_test: ao_flight_test.c ao_host.h ao_flight.c ao_sample.c ao_kalman.c altitude.h $(INCS)
	cc $(CFLAGS) -o $@ $<

ao_flight_test_noisy_accel: ao_flight_test.c ao_host.h ao_flight.c ao_sample.c ao_kalman.c $(INCS)
	cc -DNOISY_ACCEL=1 $(CFLAGS) -o $@ $<

ao_flight_test_baro: ao_flight_test.c ao_host.h ao_flight.c  ao_sample.c ao_kalman.c $(INCS)
	cc $(CFLAGS) -o $@ -DHAS_ACCEL=0 ao_flight_test.c

ao_flight_test_accel: ao_flight_test.c ao_host.h ao_flight.c  ao_sample.c ao_kalman.c $(INCS)
	cc $(CFLAGS) -o $@ -DFORCE_ACCEL=1 ao_flight_test.c

ao_flight_test_mm: ao_flight_test.c ao_host.h ao_flight.c ao_sample.c ao_kalman.c ao_pyro.c ao_pyro.h $(INCS)
	cc -DTELEMEGA=1 $(CFLAGS) -o $@ $< -lm

ao_flight_test_metrum: ao_flight_test.c ao_host.h ao_flight.c ao_sample.c ao_kalman.c ao_pyro.c ao_pyro.h $(INCS)
	cc -DTELEMETRUM_V2=1 $(CFLAGS) -o $@ $< -lm

ao_flight_test_mini: ao_flight_test.c ao_host.h ao_flight.c ao_sample.c ao_kalman.c ao_pyro.c ao_pyro.h $(INCS)
	cc -DEASYMINI=1 -DHAS_ACCEL=0 $(CFLAGS) -o $@ $< -lm

ao_gps_test: ao_gps_test.c ao_gps_sirf.c ao_gps_print.c ao_host.h
	cc $(CFLAGS) -o $@ $<

ao_gps_test_skytraq: ao_gps_test_skytraq.c ao_gps_skytraq.c ao_gps_print.c ao_gps_show.c ao_host.h
	cc $(CFLAGS) -o $@ $<

ao_gps_test_ublox: ao_gps_test_ublox.c ao_gps_ublox.c ao_gps_print.c ao_gps_show.c ao_host.h ao_gps_ublox.h
	cc $(CFLAGS) -o $@ $<

ao_convert_test: ao_convert_test.c ao_convert.c altitude.h
	cc $(CFLAGS) -o $@ $<

ao_convert_pa_test: ao_convert_pa_test.c ao_convert_pa.c altitude-pa.h
	cc $(CFLAGS) -o $@ $<

ao_kalman.h: $(KALMAN)
	(cd .. && make ao_kalman.h)

ao_fec_test: ao_fec_test.c ao_fec_tx.c ao_fec_rx.c
	cc $(CFLAGS) -DAO_FEC_DEBUG=1 -o $@ ao_fec_test.c ../kernel/ao_fec_tx.c ../kernel/ao_fec_rx.c -lm

ao_aprs_test: ao_aprs_test.c ao_aprs.c
	cc $(CFLAGS) -o $@ ao_aprs_test.c -lm

SOX_INPUT_ARGS=--type raw --encoding unsigned-integer -b 8 -c 1 -r 9600
SOX_OUTPUT_ARGS=--type wav

ao_aprs_data.wav: ao_aprs_test
	./ao_aprs_test | sox $(SOX_INPUT_ARGS) - $(SOX_OUTPUT_ARGS) $@

check: ao_fec_test ao_flight_test ao_flight_test_baro run-tests
	./ao_fec_test && ./run-tests

ao_micropeak_test: ao_micropeak_test.c ao_microflight.c ao_kalman.h
	cc $(CFLAGS) -o $@ ao_micropeak_test.c -lm

ao_fat_test: ao_fat_test.c ao_fat.c ao_bufio.c
	cc $(CFLAGS) -o $@ ao_fat_test.c -lssl -lcrypto

ao_aes_test: ao_aes_test.c ao_aes.c ao_aes_tables.c
	cc $(CFLAGS) -o $@ ao_aes_test.c

ao_int64_test: ao_int64_test.c ao_int64.c ao_int64.h
	cc $(CFLAGS) -o $@ ao_int64_test.c

ao_ms5607_convert_test: ao_ms5607_convert_test.c ao_ms5607_convert_8051.c ao_int64.c ao_int64.h
	cc $(CFLAGS) -o $@ ao_ms5607_convert_test.c

ao_quaternion_test: ao_quaternion_test.c ao_quaternion.h
	cc $(CFLAGS) -o $@ ao_quaternion_test.c -lm

AO_LISP_OBJS = ao_lisp_test.o ao_lisp_mem.o  ao_lisp_cons.o ao_lisp_string.o \
	ao_lisp_atom.o ao_lisp_int.o ao_lisp_eval.o ao_lisp_poly.o \
	ao_lisp_builtin.o ao_lisp_read.o ao_lisp_rep.o ao_lisp_frame.o \
	ao_lisp_lambda.o ao_lisp_error.o ao_lisp_save.o ao_lisp_stack.o

ao_lisp_test: $(AO_LISP_OBJS)
	cc $(CFLAGS) -o $@ $(AO_LISP_OBJS)

$(AO_LISP_OBJS): ao_lisp.h ao_lisp_const.h ao_lisp_os.h

=== debian/changelog ===
altos (1.8-1) unstable; urgency=medium

  [ Bdale Garbee ]
  * two more places where telemini-outline.pdf filename needs to be updated
  * add telemini-v3.0 to list of binaries we stach in LLC repo for production use
  * telebt-v4.0: initial creation of firmware for new product, no BT yet
  * telebt-v4.0: add ao_send_packet
  * telebt-v4.0: don't need the USB pin remapping flag
  * telebt-v4.0: turn off pin remapping in the flash loader, too
  * telebt-v4.0: slow down SPI speed to radio chip
  * telegps-v2.0: slow down radio chip spi speed
  * telebt-v4.0: make git ignore products of build
  * ao-tools/ao-makebin: have git ignore built object
  * telemini-v3.0: make git ignore build products
  * altos/telebt-v4.0 Set CPU clock to 48Mhz instead of 96Mhz
  * telegps: use new eeprom reading code
  * have git ignore ao-bringup/cal_values
  * telefiretwo: don't try to record pre-burn sensor values in FLIGHT record
  * initial tests made using Terry's stand with a 2500psi sensor
  * have AltosGraph use new AltosPressure to get imperial_units working
  * re-brand current telefiretwo product as telefireone
  * altoslib: include TimeSeries code in build
  * add thrust as a graphable time series type
  * rename existing turnon_telebt script, create a new one for v4.0
  * clean up telefireone name references
  * ignore more build products in telebt-v4.0 tree
  * add TeleBT v4.0 to the list of stuff we build
  * remove libssl-dev build dependency, only used by test code we don't build
  * update docinfo file for 1.8 release
  * releasing 1.8

  [ Keith Packard ]
  * altos/stmf0: Not all timer configurations use AF2
  * altos/telemini-v3.0: Fix license
  * altos/easymini-v2.0: Add EasyMini v2.0
  * altos: Add telemini-v3.0 and easymini-v2.0 to default altos build
  * altosui: Ship telemini v3.0 firmware
  * altos/ao-bringup: Switch turnon_easymini to v2.0
  * altosui: Add TeleMini v3.0 and EasyMini v2.0 firmware to windows package
  * Update releasing to add more firmware bits
  * Ignore ao_lisp_test
  * altos/telegps-v2.0: git ignore make results
  * altos/nucleo-32: Add lisp save/restore
  * ao-bringup: make turnon_telemini search for ao_usbload on $PATH
  * Fake thrust data as accel for now
  * micropeak: Add MicroPeak V2 to the download code
  * altos/ms5607: Allow applications to not use the normal data ring and thread
  * altos: Adapt micro log to MicroPeak V3
  * altos: Add 100ms constants for baro Kalman filter
  * altos: Add header file for ao_report_micro.c
  * altos/micropeak: Use existing ao_ms5607_current variable
  * altos/micropeak: Update ao_micropeak.h for MicroPeak v2
  * altos/stmf0: Compute serial baud rate registers at runtime
  * altos/stmf0: Make sure systick is off before programming
  * altos/stmf0: Fix HSI clock rate.
  * altos/stmf0: Add support for HSI clocked applications
  * altos/micropeak-v2.0: Add initial MicroPeak v2 support
  * altos: Build MicroPeak-v2.0 by default
  * src/kernel: Add GPS lock blink LED to tracker code
  * altos/kernel: Allow TeleGPS v2 to scale battery in telem
  * altos/telegps-v2.0: Adjust LED config
  * altos/telegps-v2.0: Set CPU clock to 48MHz instread of 96MHz
  * altos/telegps-v2.0: Battery ADC input is on PB1, not PA0
  * altos/telegps-v2.0: Remove some unneeded defines
  * altos/telegps-v2.0: GPS chip is connected to serial 2, not serial 1
  * altos/telegps-v2.0: CC1200 CS is PA1, not PA5.
  * altos/telegps-v2.0: Reorder initialization sequence
  * altos/stmf0: Add code to use SoC flash as storage
  * altos/telegps-v2.0: Disable external serial port to save ROM
  * altos: Make CDC ACM 'line coding' public
  * altos: Move 'ao_force_freq' to ao_config.c
  * altos/telemini-v3.0: Add 'recovery mode' on PA14 (pin 6 on dbg header)
  * altos/telemini-v3.0: Use dbg connector pin 5 for force bootloader
  * altoslib: Hide members from json by prefixing with __
  * altoslib: Add AltosForce and AltosPressure units
  * altoslib: Add Ms5607 constructor that just takes config_data
  * altoslib: Add empty constructor for AltosPyro for JSON
  * altoslib: Add set_config_data to AltosState
  * altoslib: Add new eeprom management code
  * altoslib: Compile AltosForce and AltosPressure
  * altoslib: Hack up AltosEepromFile to support new eeprom code
  * altosui: Use new eeprom reading code
  * altoslib: Save eeprom data in new .eeprom format
  * altoslib: Remove older eeprom handling code
  * altoslib: Another bit of altoslib for the old eeprom stuff
  * Use SDP to locate the service channel on Linux
  * altos: Add RN4678 Bluetooth module driver
  * altos/telebt-v4.0: Hook up RN4678 module
  * altoslib: Handle TeleBT v4.0 battery voltage
  * libaltos: Add support for TeleBT-v4.0 bluetooth channel change
  * altos/stmf: Fix up serial port flow control configuration bits
  * altos/ao_rn4678: Send '$$$' for new devices. Fix name setting code.
  * altoslib: Mark AltosConfigData fields as MISSING until set
  * altoslib: Set default log format to FULL until we learn different
  * altoslib: Set default accel cal for old TeleMetrum v1 files
  * altos/telefireone-v1.0: Fix confusing defines about config storage
  * ao-bringup: turnon_chaoskey: search for ao-usbload in PATH
  * altos/telebt-v4.0: Remove HAS_POLLCHAR
  * altos/telebt-v3.0: Add send_packet command
  * altoslib: Add initial time series functions
  * altosuilib: Add time series subclass with data for generating a plot
  * altoslib: Create new abstraction underneath AltosState for recording values
  * altosuilib: Start creating new graph interface that takes time series data
  * altosui: Hacks to plug into the new graph stuff
  * doc: Add telegps outline
  * altoslib: Don't store computed telemetry fields
  * altoslib: Do data analysis on raw values rather than AltosState
  * altosuilib: Adapt to AltosFlightSeries data processing plan
  * altosui: Adapt to AltosFlightSeries for data analysis
  * altoslib/altosuilib/altosui: More work towards using AltosFlightSeries for analysis


=== debian/control ===
Source: altos
Section: electronics
Priority: optional
Maintainer: Bdale Garbee <bdale@gag.com>
Uploaders: Keith Packard <keithp@keithp.com>
Build-Depends: asciidoc,
               autoconf,
               automake,
               cc1111,
               debhelper (>= 7),
               default-jdk,
               docbook-xml,
               docbook-xsl,
               fop,
               freetts,
               gawk,
               gcc-arm-none-eabi,
               graphicsmagick | imagemagick,
               icnsutils,
               icoutils,
               libbluetooth-dev,
               libelf-dev,
               gtk-update-icon-cache,
               libjfreechart-java,
               libreadline-dev,
               librsvg2-bin,
               libtool,
               libusb-1.0-0-dev,
               netpbm,
               nickle,
               pkg-config,
               shared-mime-info,
               swig,
               xmlto,
               xsltproc
Standards-Version: 3.9.8
Homepage: http://altusmetrum.org/AltOS
Vcs-Git: git://git.gag.com/fw/altos -b debian
Vcs-Browser: http://git.gag.com/?p=fw/altos

Package: altos
Architecture: any
Depends: default-jre | java2-runtime,
         freetts,
         libjfreechart-java,
         nickle,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: slim | gdm
Replaces: altusmetrum-themes, slim-altusmetrum
Conflicts: altusmetrum-themes, slim-altusmetrum
Description: Altus Metrum firmware and utilities
 Firmware and utilities needed to support high power model rocketry products
 from Altus Metrum, including TeleMetrum, TeleMini, and TeleDongle.
 .
 See http://altusmetrum.org/ for more information.
